#!/usr/bin/python3
# -*- coding: utf-8 -*-

# chat_list.py: simple List-Extension

import time

class DirList:
    ## für Directory 
    ## DirListe=[]
    ## DirMax=5     
    
    def __init__(self):
        self.DirListe=[] 
        self.DirMax=5


    def listLength(self):
        """Retour: Länge der Liste"""
        
        if self.DirListe != []:
            return len(self.DirListe)
        else:
            return -1

    def delEntry(self,element):
        """Löscht 'element' aus Liste"""
        debug = 0        
        if (self.listLength() > 0): ## Liste leer?
            if element in self.DirListe:
                self.DirListe.remove(element)
            else:    
                if debug:
                    print( 'Element "' + element + '" nicht in der Liste . . .')
            


    def resetList(self):
        """Initialisiert die Liste"""
        self.DirListe=[]

    def addEntry(self,element):
        """Fügt 'element' zur Liste hinzu"""        
        debug = 0
        if debug:
            print( element )
        laenge = self.listLength()
        if (laenge < 1):  ## Liste leer!
            self.DirListe.append(element)
        else: ## laenge >= 1            
            if not(element in self.DirListe):                
                if (laenge < self.DirMax):
                    self.DirListe.append(element)
                else:  ## Liste voll, schlafen!
                    if debug:
                        #print( "Eine Runde schlafen . . ." )
                        self.printList()                        
                    #time.sleep(1)
            else:   # Element ist schon in der Liste 
                #self.resetList()
                #self.DirListe.append(element)
                pass  
        #self.printList()
            

        
    def printList(self,argument=""):
        """Ausgabe-Methode für die Liste"""    
        laenge = self.listLength()
        if (laenge > 0):
            print( argument + 'Elemente der DirListe: ' )
            for element in self.DirListe:
                print( element )
        else:
            print( 'Liste leer!!' )
        


def mainDirTest():
    """Test-Methode für die Klasse"""
    test = DirList()
    test.resetList()
    test.addEntry('Eintrag 1')
    test.printList(argument="1: ")    
    test.addEntry('Eintrag 2')
    test.printList(argument="2: ")
    test.addEntry('Eintrag 3')
    test.printList(argument="3: ")      
    test.addEntry('Eintrag 4')
    test.printList(argument="4: ")      
    test.addEntry('Eintrag 5')  
    test.printList(argument="5: ")  
    test.addEntry('5. Eintrag')
    test.printList(argument="6: ")
    test.addEntry('Eintrag Nr. 6')
    test.addEntry('Eintrag Nr. 6')
    test.addEntry('Eintrag Nr. 6')
    test.addEntry('Eintrag Nr. 6')
    test.addEntry('Eintrag Nr. 6')    
    test.addEntry('Eintrag Nr. 6')
    test.addEntry('Eintrag Nr. 6')
    test.addEntry('Eintrag 6')
    test.printList(argument="7: ")
    
    

## main
if  __name__ == '__main__':
    print( "\n\nTest der DirList-Klasse" )
    mainDirTest()

